<template>
  <BasicModal v-bind="$attrs" @register="registerModal" destroyOnClose :title="title" :width="800" @ok="handleSubmit" :closeFunc="handlerCloseFunc">
    <template #footer >
        <a-button v-show="!isDetail &&(pFlag || isUpdate)" key="back" @click="handleCancel">取消</a-button>
        <a-button v-show="pFlag" key="submit" type="primary" @click="handleNext">下一步</a-button>
        <a-button v-show="!pFlag && !isUpdate" key="back" @click="handleUpper">上一步</a-button>
        <a-button v-show="!isDetail && !pFlag" key="submit" type="primary" @click="handleSubmit">{{ btnName }}</a-button>
      </template>  
    <ActSelect v-show="pFlag" :actinfo="actinfo"/>
    <ProblemSelect v-show="!pFlag && sFlag" :actinfo="proinfo" ref="pSref" @select="onProblemSelect"></ProblemSelect>
    <BasicForm v-show="!pFlag && !sFlag" @register="registerForm"/>
  </BasicModal>
</template>

<script lang="ts" setup>
    import { message } from 'ant-design-vue';
import { computed, ref, unref } from 'vue';
import ActSelect from '../../components/ActSelect.vue';
import ProblemSelect from '../../components/ProblemSelect.vue';
import { saveOrUpdate } from '../StProblem.api';
import { formSchema } from '../StProblem.data';
import { BasicForm, useForm } from '/@/components/Form/index';
import { BasicModal, useModalInner } from '/@/components/Modal';
    const pFlag = ref(true)
    const sFlag = ref(true)
    // Emits声明
    const emit = defineEmits(['register','success']);
    const isUpdate = ref(true);
    const actinfo = ref({})
    const proinfo = ref({})
    const pSref = ref(null)
    const btnName = ref('确定')
    const isDetail = ref(false);
    //表单配置
    const [registerForm, {setProps,resetFields, setFieldsValue, validate}] = useForm({
        //labelWidth: 150,
        schemas: formSchema,
        showActionButtonGroup: false,
        baseColProps: {span: 24}
    });
    //表单赋值
    const [registerModal, {setModalProps, closeModal}] = useModalInner(async (data) => {
        //重置表单
        await resetFields();
        setModalProps({confirmLoading: false,showCancelBtn:!!data?.showFooter,showOkBtn:!!data?.showFooter});
        isUpdate.value = !!data?.isUpdate;
        isDetail.value = !data?.showFooter
        if (unref(isUpdate)) {
            //表单赋值
            await setFieldsValue({
                ...data.record,
            });
          // 改变pFlag状态
          pFlag.value = false
          sFlag.value = false
          btnName.value = "确定"
        }else{
            setFieldsValue({
                complianeNo: data?.complianeNo,
            }); 
            pFlag.value = true
            sFlag.value = true
            btnName.value = '去创建问题'
        }
        // 隐藏底部时禁用整个表单
       setProps({ disabled: !data?.showFooter })
    });
    //设置标题
    //设置标题
    const title = computed(() => (pFlag.value?'选择控制活动':!unref(isUpdate) ? (unref(sFlag)?'选择问题':'填写问题'): '查看问题'));
    function handlerCloseFunc(){
        pFlag.value = true
        sFlag.value = true
        if(actinfo.value.caNo){
            actinfo.value = {}
        }
        if(proinfo.value.id){
            proinfo.value = {}
        }
        return new Promise((res,rej)=>{res(true)})
    }
    function onProblemSelect(selected){
        console.log(selected)
        if(selected){
            btnName.value = "确定"
        }else{
            btnName.value = "去创建问题"
        }
    }
    function handleUpper() {
        if(!pFlag.value && !sFlag.value){
            btnName.value = "去创建问题"
            sFlag.value = true
        }else{
            pFlag.value = true
        }
    }
    function handleNext() {
        console.log(actinfo)
        if(!actinfo.value.caNo){
            message.warn("请选择控制活动！")
            return
        }
        pFlag.value = false
        actinfo.value.id = ''
        pSref.value?.toQueryByCaNo(actinfo.value.caNo)
        btnName.value = "去创建问题"
        setFieldsValue({
            ...actinfo.value,
        });
    }
    function handleCancel() {
        if(actinfo.value.caNo){
            actinfo.value = {}
        }
        if(proinfo.value.id){
            proinfo.value = {}
        }
        closeModal()
    }
    //表单提交事件
    async function handleSubmit(v) {
        if(!pFlag.value && sFlag.value ){
            if(!!proinfo.value.id){
                console.log(proinfo.value)
                setFieldsValue({
                    id:proinfo.value.id,
                    problemItem:proinfo.value.problemItem,
                    problemExample:proinfo.value.problemExample,
                });
                try {
                    let values = await validate();
                    setModalProps({confirmLoading: true});
                    //提交表单
                    await saveOrUpdate(values, true);
                    //关闭弹窗
                    closeModal();
                    //刷新列表
                    emit('success');
                } finally {
                    setModalProps({confirmLoading: false});
                }
            }else{
                sFlag.value = false
                btnName.value = "确定"
            }
        }else{
            try {
                let values = await validate();
                setModalProps({confirmLoading: true});
                //提交表单
                await saveOrUpdate(values, isUpdate.value);
                //关闭弹窗
                closeModal();
                //刷新列表
                emit('success');
            } finally {
                setModalProps({confirmLoading: false});
            }
        }
    }
</script>

<style lang="less" scoped>
	/** 时间和数字输入框样式 */
  :deep(.ant-input-number){
		width: 100%
	}

	:deep(.ant-calendar-picker){
		width: 100%
	}
</style>